﻿<?php
/**	plugin.simplcp.php
 *	Checkpoint plugin for XAseco by Lambda, 2009
 *	Configuration file: simplcp.xml
 *	Copy this file to xaseco plugins folder
 */	

Aseco::registerEvent('onPlayerFinish', 'simpl_cp_del');
Aseco::registerEvent('onCheckpoint', 'simpl_cp_checkpoint');
Aseco::registerEvent('onEndRound', 'simpl_cp_end');
Aseco::registerEvent('onPlayerInfoChanged', 'player_spec');      
	
	global $all_cps;

	// onPlayerFinish (delete)
	function simpl_cp_del($lambda, $pl_end) {
	global $all_cps;	

	$end_pl_log = $pl_end->player->login;	//login

        $lambda->client->query('GetCurrentChallengeInfo');
        $CCInfo = $lambda->client->getResponse();
        $all_cps = ($CCInfo["NbCheckpoints"])-1; //last cp = finish
	
	//frame posn from config .xml
	$frame_posn_simplcp = simplexml_load_file('simplcp.xml');

	$frame_posn_x = $frame_posn_simplcp->left_top_point->hx;
	$frame_posn_y = $frame_posn_simplcp->left_top_point->vy;
	$text_color = $frame_posn_simplcp->cpcolor->cptext;	
	$delim_color = $frame_posn_simplcp->cpcolor->delimitercolor;
	$delim_text = $frame_posn_simplcp->textstring->delimitertext;
	$number_color = $frame_posn_simplcp->cpcolor->cpnumber;
	
	$xml = '<?xml version="1.0" encoding="UTF-8"?>';
    $xml .= '<manialink id="01928374">';
    $xml .= '<frame posn="'.$frame_posn_x.' '.$frame_posn_y.' 0.3">';
    $xml .= '<quad posn="-23.38 19.1 0.3" sizen="16 4" style="Bgs1InRace" substyle="NavButton"/>';
	$xml .= '<label scale="0.3" posn="-15.3 16.1 0.6" halign="center" valign="center" style="TextRaceMessage" text="$'.$text_color.'Checkpoints counter:"/>';
	$xml .= '<label scale="0.4" posn="-16.4 17.7 0.1" halign="right" valign="center" style="TextRaceChrono" text="$'.$number_color.'0"/>';
	$xml .= '<label scale="0.4" posn="-15.6 17.7 0.1" halign="left" valign="center" style="TextRaceChrono" text="$'.$delim_color.''.$delim_text.' $'.$number_color.''.$all_cps.'"/>';
	$xml .= '</frame>';
	$xml .= '</manialink>';
	$lambda->client->query("SendDisplayManialinkPageToLogin", $end_pl_log, $xml, 0, false);   
	}	

	//onCheckpoint
	function simpl_cp_checkpoint($lambda, $num_curr_cp) {
	global $all_cps;

	$pl_log = $num_curr_cp[1]; //login

	$tre_cp = ($num_curr_cp[4])+1; // 1=0
	
	// frame posn from config simplcp.xml
	$frame_posn_simplcp = simplexml_load_file('simplcp.xml');

	$frame_posn_x = $frame_posn_simplcp->left_top_point->hx;
	$frame_posn_y = $frame_posn_simplcp->left_top_point->vy;
	$text_color = $frame_posn_simplcp->cpcolor->cptext;
	$text_fcolor = $frame_posn_simplcp->cpcolor->lastcpcolor;
	$text_lastcp = $frame_posn_simplcp->textstring->lastcptext;	
	$delim_color = $frame_posn_simplcp->cpcolor->delimitercolor;
	$delim_text = $frame_posn_simplcp->textstring->delimitertext;
	$number_color = $frame_posn_simplcp->cpcolor->cpnumber;

	
	$xml = '<?xml version="1.0" encoding="UTF-8"?>';
    $xml .= '<manialink id="01928374">';
    $xml .= '<frame posn="'.$frame_posn_x.' '.$frame_posn_y.' 0.3">';
    $xml .= '<quad posn="-23.38 19.1 0.3" sizen="16 4" style="Bgs1InRace" substyle="NavButton"/>';
	$xml .= '<label scale="0.3" posn="-15.3 16.1 0.6" halign="center" valign="center" style="TextRaceMessage" text="$'.$text_color.'Checkpoints counter:"/>';
	if ($tre_cp === $all_cps){
		$xml .= '<label scale="0.8" posn="-15.2 17.75 1" halign="center" valign="center" style="TextTitle2Blink" text="$'.$text_fcolor.''.$text_lastcp.'"/>';
	}
	else{
	$xml .= '<label scale="0.4" posn="-16.4 17.7 0.1" halign="right" valign="center" style="TextRaceChrono" text="$'.$number_color.''.$tre_cp.'"/>';
	$xml .= '<label scale="0.4" posn="-15.6 17.7 0.1" halign="left" valign="center" style="TextRaceChrono" text="$'.$delim_color.''.$delim_text.' $'.$number_color.''.$all_cps.'"/>';
		}
	$xml .= '</frame>';
	$xml .= '</manialink>';
	$lambda->client->query("SendDisplayManialinkPageToLogin", $pl_log, $xml, 0, false);
	}
	
	//onEndRace
	function simpl_cp_end($lambda) {

	$frame_posn_simplcp = simplexml_load_file('simplcp.xml');

	$frame_posn_x = $frame_posn_simplcp->left_top_point->hx;
	$frame_posn_y = $frame_posn_simplcp->left_top_point->vy;
	$text_color = $frame_posn_simplcp->cpcolor->cptext;
	$number_end_color = $frame_posn_simplcp->cpcolor->colorendtext;
	$number_end_text = $frame_posn_simplcp->textstring->endtext;
	
	$xml = '<?xml version="1.0" encoding="UTF-8"?>';
	$xml .= '<manialink id="01928374">';
    $xml .= '<frame posn="'.$frame_posn_x.''.$frame_posn_y.' 0.3">';
    $xml .= '<quad posn="-23.38 19.1 0.3" sizen="16 4" style="Bgs1InRace" substyle="NavButton"/>';
	$xml .= '<label scale="0.3" posn="-15.3 16.1 0.6" halign="center" valign="center" style="TextRaceMessage" text="$'.$text_color.'Checkpoints counter:"/>';
	$xml .= '<label scale="0.8" posn="-15.2 17.75 1" halign="center" valign="center" style="TextRaceMessage" text="$'.$number_end_color.''.$number_end_text.'"/>';
	$xml .= '</frame>';
	$xml .= '</manialink>';
	$lambda->client->query("SendDisplayManialinkPage", $xml, 1, false);
	}

	//onPlayerInfoChanged
	function player_spec($lambda, $info) {
		$login = $info['Login'];
		$status = $info['SpectatorStatus'];
		
		if ($status != 0){
		$xml = '<?xml version="1.0" encoding="UTF-8"?>';
		$xml = '<manialink id="01928374"></manialink>';
		$lambda->client->query("SendDisplayManialinkPageToLogin",$login, $xml, 1, false);
		}
	}

?>
